#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';

struct MyStruct
{
    lli x, ind;
};

vector<lli> a;
vector<MyStruct> b;
vector<lli> res;
deque<lli> d1;
deque<lli> d2;


bool cmp(MyStruct b1, MyStruct b2)
{
    return b1.x < b2.x;
}


void solve()
{
    lli n, m,k;
    cin >> n >> m >> k;
    a.resize(n + 1);
    res.resize(m + 1);
    for (int i = 1; i <= n; i++)cin >> a[i];
    b.resize(m + 1);
    for (int i = 1; i <= m; i++) {
        cin >> b[i].x;
        b[i].ind = i;
    }

    sort(a.begin() + 1, a.end());
    sort(b.begin() + 1, b.end(),cmp);

    lli tl = 1;
    for (int i = 1; i <= m; i++) {
        while (tl < n && a[tl] < b[i].x)tl++;
        if (a[tl]>=b[i].x && a[tl]<b[i].x+k)res[b[i].ind] = k - (a[tl] - b[i].x);
        if (tl != 1 && a[tl-1]+k>b[i].x)res[b[i].ind] = max(res[b[i].ind], k - (b[i].x - a[tl - 1]));
        if (a[tl]<b[i].x && a[tl]+k>b[i].x)res[b[i].ind] = max(res[b[i].ind], k - (b[i].x - a[tl]));
    }
    for (int i = 1; i <= m; i++)cout << res[i] << LF;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

