#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <numeric>
#include <queue>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';

vector<vector<lli>> v;
vector<lli> col;
vector<lli> row;

void solve()
{
    lli n, m;
    cin >> n >> m;
    v.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        v[i].resize(m + 1,0);
        for (int j = 1; j <= m; j++) {
            char c;
            cin >> c;
            if (c == '#')v[i][j] = 1;
        }
    }

    col.resize(m + 1);
    row.resize(n + 1);
    lli s = 0;
    for (int i = 1; i <= n; i++) {
        lli cnt = 0;
        for (int j = 1; j <= m; j++)cnt += v[i][j];
        row[i] = cnt;
        s += cnt;
    }

    for (int j = 1; j <= m; j++) {
        lli cnt = 0;
        for (int i = 1; i <= n; i++)cnt += v[i][j];
        col[j] = cnt;
    }

    lli tans = 0;
    for (int i = 1; i <= n; i++) {
        lli s2 = s + m - 2*row[i];
        lli tmin = 1e9;
        for (int j = 1; j <= m; j++) {
            lli s3 = s2 + n - 2*col[j];
            if (v[i][j] == 1)s3+=2;
            if (v[i][j]==0) s3-=2;
            tmin = min(tmin, s3);
        }
        tans = max(tans, tmin);
    }
    cout << tans << " " << n * m - tans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

