#include <algorithm>
#include <climits>
#include <cmath>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <vector>

using namespace std;

#define ll long long
#define lf long double
#define ull unsigned long long
#define ul unsigned long
#define nl "\n"
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll n, m, k;
  ll a, b, c, d, e, f, g, h, l, r, mx, mn, sm;
  bool bl;
  string str;
  char ch;
  cin >> n >> m >> k;
  vector<ll> bells(n);
  vector<ll> houses(m);
  for (ll i = 0; i < n; i++) {
    cin >> bells[i];
  }
  for (ll i = 0; i < m; i++) {
    cin >> houses[i];
  }
  for (ll house : houses) {
    auto it = lower_bound(all(bells), house);
    e = k - abs(*it - house);
    if (it != bells.begin()) {
      it--;
      e = max(e, k - abs(*it - house));
    }
    cout << max(e, 0ll) << nl;
  }
}
