#include<bits/stdc++.h>

using namespace std;

const int dim = 1e5+7, dim2 = 1e3+7;

int n, m, c0, c1;
int a[dim][dim2], t[dim][dim2], res1[dim];

void add(int x, int y, int val){
    x++; y++;
    for(int i = x; i<dim; i+=i&-i){
        for(int j = y; j<dim; j+=j&-j)t[i][j]+=val;
    }
}

int prefsum(int x, int y){
    x++; y++;
    int sum = 0;
    for(int i = x; i>0; i-=i&-i){
        for(int j = y; j>0; j-=j&-j)sum+=t[i][j];
    }
    return sum;
}

int sum(int x, int y, int a, int b){
    return prefsum(a, b)-prefsum(x-1, b)-prefsum(a, y-1)+prefsum(x-1, y-1);
}

void print(){
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            cout << a[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
}

int main(){

    ///
//    5 5
//    #####
//    ####.
//    ###..
//    ##...
//    #....
//    1 1 1 1 1
//    1 1 1 1 0
//    1 1 1 0 0
//    1 1 0 0 0
//    1 0 0 0 0
    ///

    char c;
    cin >> n >> m;
    bool sw = 0;
    if(m>n){swap(n, m); sw = 1;}
    c0 = 0, c1 = 0;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            cin >> c;
            if(c=='#')a[i][j] = 1;
            else a[i][j] = 0;
        }
    }
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
                add(i, j, a[i][j]);
        }
    }

    //print();
    //////////////////////////////////////

    int maxc = 0, maxpos, curmax;
    for(int i = 1; i<=n; i++){
        curmax = 0; maxpos = 1; maxc = 0;
        for(int j = 1; j<=m; j++){
            curmax = max(sum(1, j, i-1, j)+sum(i+1, j, n, j)+(a[i][j]^1), curmax);
            if(curmax>maxc)maxpos = j;
            maxc = max(maxc, curmax);
            //cout << maxpos << " ";
        }
        //cout << endl;


        res1[i]+= sum(1, 1, i-1, maxpos-1) + sum(1, maxpos+1, i-1, m) +
        sum(i+1, 1, n, maxpos-1) + sum(i+1, maxpos+1, n, m);
        int r = sum(i, 1, i, maxpos-1) + sum(i, maxpos+1, i, m);
        res1[i]+=m-1-r;
        int c = sum(1, maxpos, i-1, maxpos) + sum(i+1, maxpos, n, maxpos);
        res1[i]+=n-1-c;
        res1[i]+=a[i][maxpos];
    }

    int ma = 0;
    for(int i = 1; i<=n; i++)ma = max(ma, res1[i]);
    if(!sw)cout << ma << " " << n*m-ma;
    else cout << n*m-ma << " " << ma;

    return 0;
}
