#include<bits/stdc++.h>

using namespace std;

const long long dim = 1e9+7;

long long n, m, cnt;
vector<vector<long long>> a, used;
set<long long> dev;

void dfs(long long x, long long y, long long val){
    if(x<1 || y<1 || x>n || y>m || a[x][y]!=val || used[x][y])return;
    used[x][y] = cnt;

    dfs(x-1, y, val);
    dfs(x+1, y, val);
    dfs(x, y+1, val);
    dfs(x, y-1, val);
}

int main(){

    cin >> n >> m;
    a.reserve(n+100);
    used.reserve(n+100);
    for(int i = 1; i<=n; i++){
        a[i].reserve(m+100);
        used[i].reserve(m+100);
    }

    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            cin >> a[i][j];
            used[i][j] = 0;
        }
    }

    cnt = 0;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            if(!used[i][j]){
                cnt++;
                dfs(i, j, a[i][j]);
            }
        }
    }

    long long devc, mi = dim;
    for(int j = 1; j<m; j++){
        devc = 0;
        while(!dev.empty())dev.erase(dev.begin());
        for(int i = 1; i<=n; i++){
            if(used[i][j]==used[i][j+1] && dev.find(used[i][j])==dev.end()){
                dev.insert(used[i][j]);
                devc++;
            }
        }
        mi = min(cnt+devc, mi);
    }
    cout << mi;

    return 0;
}
