bells_count, houses_count, volume = map(int, input().split(" "))
bells = list(map(int, input().split(" ")))
houses = list(map(int, input().split(" ")))

all_objects = [(coord, 0, i) for i, coord in enumerate(bells)] + [(coord, 1, i) for i, coord in enumerate(houses)]
all_objects.sort(key=lambda pair: pair[0])

answers = [0] * houses_count

prev_bell = None
next_bell = None
have_no_next_bell = False

for i, (coord, type, index) in enumerate(all_objects):
    if type == 0:
        prev_bell = coord
        next_bell = None
    elif type == 1:
        max_sound = 0 if prev_bell is None else max(volume - (coord - prev_bell), 0)

        if have_no_next_bell:
            answers[index] = max_sound
            continue

        if next_bell is None:
            for (bell_coord, type, _) in all_objects[i + 1:]:
                if type == 0:
                    next_bell = bell_coord
                    break
            else:
                have_no_next_bell = True

        max_sound = max_sound if next_bell is None else max(max_sound, max(volume - (bell_coord - coord), 0))
        answers[index] = max_sound

for answer in answers:
    print(answer)
