#include <bits/stdc++.h>
typedef long double ld;
typedef long long ll;
using namespace std;
ll n, m;
ll table[200][200];
ll visited[200][200];
bool can(ll first, ll second, ll third, ll v){
    if(first>=0 && second>=0 && first<n && second<m){
        ll f, s;
        if(third<=v) f=0;
        else f=1;
        if(second<=v) s=0;
        else s=1;
        if(f!=s) return false;
        else return true;
    }
    else return false;
}
ll solve(ll vv){
    ll indx = 1;
    for(ll i = 0; i<n; i++){
        for(ll j = 0; j<m; j++){
            if(!visited[i][j]){
                visited[i][j]=true;
                queue<pair<ll, ll>> q;
                ll v = table[i][j];
                q.push({i, j});
                while(!q.empty()){
                    pair<ll, ll> now = q.front();
                    q.pop();
                    if(can(now.first+1, now.second, now.second, vv) && !visited[now.first+1][now.second] && table[now.first+1][now.second]==v){
                        visited[now.first+1][now.second]=true;
                        q.push({now.first+1, now.second});
                    }
                    if(can(now.first-1, now.second, now.second, vv) && !visited[now.first-1][now.second] && table[now.first-1][now.second]==v){
                        visited[now.first-1][now.second]=true;
                        q.push({now.first-1, now.second});
                    }
                    if(can(now.first, now.second+1, now.second, vv) && !visited[now.first][now.second+1] && table[now.first][now.second+1]==v){
                        visited[now.first][now.second+1]=true;
                        q.push({now.first, now.second+1});
                    }
                    if(can(now.first, now.second-1, now.second, vv) && !visited[now.first][now.second-1] && table[now.first][now.second-1]==v){
                        visited[now.first][now.second-1]=true;
                        q.push({now.first, now.second-1});
                    }
                }
                indx++;
            }
        }
    }
    return indx-1;
}
int main(){
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    ll n = 200;
    ll m = 200;
    for(ll i = 0; i<n; i++){
        for(ll j = 0; j<m; j++){
            table[i][j]=i*j+1;
        }
    }
    ll minimum = 500000;
    for(ll i = 0; i<m-1; i++){
        for(ll i = 0; i<n; i++){
            for(ll j = 0; j<m; j++){
                visited[i][j]=false;
            }
        }
        minimum=min(minimum, solve(i));
    }
    cout << minimum;
}