#include <bits/stdc++.h>
typedef long double ld;
typedef long long ll;
using namespace std;
ll n, m;
ll table[207][207];
ll visited[207][207];
bool can(ll first, ll second){
    if(first>=0 && second>=0 && first<n && second<m) return true;
    else return false;
}
bool was[207][207];
bool nn[207][207];
bool in[40007];
bool solve2(ll first, ll second){
    queue<pair<ll, ll>> q;
    nn[first][second]=true;
    ll v = table[first][second];
    q.push({first, second});
    while(!q.empty()){
        pair<ll, ll> now = q.front();
        q.pop();
        if(was[now.first][now.second]) return true;
        if(now.first+1<=first && now.second<=second && can(now.first+1, now.second) && !nn[now.first+1][now.second] && table[now.first+1][now.second]==v){
            nn[now.first+1][now.second]=true;
            q.push({now.first+1, now.second});
        }
        if(now.first-1<=first && now.second<=second && can(now.first-1, now.second) && !nn[now.first-1][now.second] && table[now.first-1][now.second]==v){
            nn[now.first-1][now.second]=true;
            q.push({now.first-1, now.second});
        }
        if(now.first<=first && now.second+1<=second && can(now.first, now.second+1) && !nn[now.first][now.second+1] && table[now.first][now.second+1]==v){
            nn[now.first][now.second+1]=true;
            q.push({now.first, now.second+1});
        }
        if(now.first<=first && now.second-1<=second && can(now.first, now.second-1) && !nn[now.first][now.second-1] && table[now.first][now.second-1]==v){
            nn[now.first][now.second-1]=true;
            q.push({now.first, now.second-1});
        }
    }
    return false;
}
bool solve3(ll first, ll second){
    queue<pair<ll, ll>> q;
    nn[first][second]=true;
    ll v = table[first][second];
    q.push({first, second});
    while(!q.empty()){
        pair<ll, ll> now = q.front();
        q.pop();
        if(was[now.first][now.second]) return true;
        if(now.first+1<=first && now.second>=second && can(now.first+1, now.second) && !nn[now.first+1][now.second] && table[now.first+1][now.second]==v){
            nn[now.first+1][now.second]=true;
            q.push({now.first+1, now.second});
        }
        if(now.first-1<=first && now.second>=second && can(now.first-1, now.second) && !nn[now.first-1][now.second] && table[now.first-1][now.second]==v){
            nn[now.first-1][now.second]=true;
            q.push({now.first-1, now.second});
        }
        if(now.first<=first && now.second+1>=second && can(now.first, now.second+1) && !nn[now.first][now.second+1] && table[now.first][now.second+1]==v){
            nn[now.first][now.second+1]=true;
            q.push({now.first, now.second+1});
        }
        if(now.first<=first && now.second-1>=second && can(now.first, now.second-1) && !nn[now.first][now.second-1] && table[now.first][now.second-1]==v){
            nn[now.first][now.second-1]=true;
            q.push({now.first, now.second-1});
        }
    }
    return false;
}
ll solve(ll v){
    ll count = 0;
    for(ll i = 0; i<n; i++){
        if(table[i][v]==table[i][v+1]){
            if(!in[visited[i][v]]){ was[i][v]=true; was[i][v+1]=true; in[visited[i][v]]=true; count++;}
            else{
                for(ll k = 0; k<n; k++){
                    for(ll j = 0; j<m; j++) nn[k][j]=false;
                }
                if(!solve2(i, v)) count++;
                for(ll k = 0; k<n; k++){
                    for(ll j = 0; j<m; j++) nn[k][j]=false;
                }
                if(!solve3(i, v+1)) count++;
                was[i][v]=true;
                was[i][v+1]=true;
            }
        }
    }
    return count;
}
int main(){
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    cin >> n >> m;
    for(ll i = 0; i<n; i++){
        for(ll j = 0; j<m; j++){
            cin >> table[i][j];
        }
    }
    ll indx = 1;
    ll count = 0;
    for(ll i = 0; i<n; i++){
        for(ll j = 0; j<m; j++){
            if(!visited[i][j]){
                visited[i][j]=indx;
                queue<pair<ll, ll>> q;
                ll v = table[i][j];
                q.push({i, j});
                while(!q.empty()){
                    pair<ll, ll> now = q.front();
                    q.pop();
                    if(can(now.first+1, now.second) && !visited[now.first+1][now.second] && table[now.first+1][now.second]==v){
                        visited[now.first+1][now.second]=indx;
                        q.push({now.first+1, now.second});
                    }
                    if(can(now.first-1, now.second) && !visited[now.first-1][now.second] && table[now.first-1][now.second]==v){
                        visited[now.first-1][now.second]=indx;
                        q.push({now.first-1, now.second});
                    }
                    if(can(now.first, now.second+1) && !visited[now.first][now.second+1] && table[now.first][now.second+1]==v){
                        visited[now.first][now.second+1]=indx;
                        q.push({now.first, now.second+1});
                    }
                    if(can(now.first, now.second-1) && !visited[now.first][now.second-1] && table[now.first][now.second-1]==v){
                        visited[now.first][now.second-1]=indx;
                        q.push({now.first, now.second-1});
                    }
                }
                indx++;
            }
        }
    }
    ll minimum = 500000;
    for(ll i = 0; i<m-1; i++){
        for(ll j = 0; j<40001; j++) in[j]=false;
        minimum=min(minimum, solve(i)+indx-1);
    }
    cout << minimum;
}