#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

ll solve(ll maxind, vector<vector<char>> pole, vector<ll> h1, vector<ll> w1, ll h, ll w) {
	for (ll i = 0; i < w; i++) {
		if (pole[i][maxind] == '.') {
			pole[i][maxind] = '#';
			h1[i]--;
			w1[maxind]--;
		}
		else {
			pole[i][maxind] = '.';
			h1[i]++;
			w1[maxind]++;
		}
	}
	ll max = 1000000000;
	for (ll i = 0; i < w; i++) {
		if (h1[i] < max) {
			max = h1[i];
			maxind = i;
		}
	}
	for (ll i = 0; i < h; i++) {
		if (pole[maxind][i] == '.') {
			w1[i]--;
			h1[maxind]--;
		}
		else {
			w1[i]++;
			h1[maxind]++;
		}
	}
	ll sum = 0, allsum = h * w;
	for (ll i = 0; i < w; i++) {
		sum += h1[i];
	}
	return sum;
}

int main() {
	ll h, w, max = 1000000000, maxind, allsum, s;
	cin >> h >> w;
	allsum = h * w;
	vector<vector<char>> pole(w, vector<char> (h));
	vector<ll> h1(w, 0); 
	vector<ll> w1(h, 0);
	for (ll i = 0; i < w; i++) {
		for (ll j = 0; j < h; j++) {
			cin >> pole[i][j];
			if (pole[i][j] == '.') {
				h1[i]++; w1[j]++;
			}
		}
	}
	for (ll i = 0; i < h; i++) {
		s = solve(i, pole, h1, w1, h, w);
		if (allsum - s > allsum - max) {
			max = s;
			maxind = i;
		}
	}
	cout << allsum - max << ' ' << max << '\n';
}