#include <iostream>
#include <vector>
#include <queue>

using namespace std;
using ll = long long;

queue<pair<ll, ll>> ab;

void bfs(vector<vector<bool>>& used, vector<vector<ll>> a, ll h, ll w) {
	if (!used[ab.front().first][ab.front().second]) {
		used[ab.front().first][ab.front().second] = true;
		if (ab.front().first < h - 1 && !used[ab.front().first + 1][ab.front().second] && a[ab.front().first + 1][ab.front().second] == a[ab.front().first][ab.front().second]) {
			ab.push({ ab.front().first + 1, ab.front().second });
		}
		if (ab.front().second < w - 1 && !used[ab.front().first][ab.front().second + 1] && a[ab.front().first][ab.front().second + 1] == a[ab.front().first][ab.front().second]) {
			ab.push({ ab.front().first, ab.front().second + 1 });
		}
		if (ab.front().first > 0 && !used[ab.front().first - 1][ab.front().second] && a[ab.front().first - 1][ab.front().second] == a[ab.front().first][ab.front().second]) {
			ab.push({ ab.front().first - 1, ab.front().second });
		}
		if (ab.front().second > 0 && !used[ab.front().first][ab.front().second - 1] && a[ab.front().first][ab.front().second - 1] == a[ab.front().first][ab.front().second]) {
			ab.push({ ab.front().first, ab.front().second - 1 });
		}
	}
}

int main() {
	ll h, w, numof = 0, ans1 = 0, ans2 = 2, coordx = 0, coordy = 0;
	cin >> h >> w;
	vector<vector<ll>> a(h, vector<ll>(w));
	vector<vector<bool>> used(h, vector<bool>(w, false));
	for (ll i = 0; i < h; i++) {
		for (ll j = 0; j < w; j++) {
			cin >> a[i][j];
		}
	}
	bool abra;
	do {
		ab.push({ coordx, coordy });
		while (!ab.empty()) {
			bfs(used, a, h, w);
			ab.pop();
		}
		abra = false;
		for (ll i = 0; i < h; i++) {
			for (ll j = 0; j < w; j++) {
				if (!used[i][j]) {
					abra = true;
					coordx = i;
					coordy = j;
					break;
				}
			}
		}
		numof++;
	} while (abra);
	if (h == 1) {
		if (numof == 1) {
			cout << 2 << '\n';
		}
		else {
			cout << numof << '\n';
		}
	}
	else if (h == 2) {
		for (ll i = 0; i < w - 1; i++) {
			ans1 = 0;
			for (ll j = 0; j < h; j++) {
				if (a[j][i] == a[j][i + 1]) {
					ans1++;
				}
				if (a[1][i] != a[0][i] && a[j][i] == a[j][i + 1]) {
					ans1++;
				}
			}
			ans2 = min(ans2, ans1);
		}
		cout << numof + ans2 << '\n';
	}
}