#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <numeric>
#include <queue>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';

vector<vector<lli>> arr;
vector<lli> cntpref;
vector<lli> cntsuf;
vector<lli> dsu;


lli finddad(lli ind)
{
    if (dsu[ind] == ind)return ind;
    else return dsu[ind] = finddad(dsu[ind]);
}

void merge(lli ind1, lli ind2)
{
    lli d1 = finddad(ind1);
    lli d2 = finddad(ind2);
    if (rand() % 2)dsu[d1] = d2;
    else dsu[d2] = d1;
}

void func(lli ind1, lli ind2, lli& cnt)
{
    if (finddad(ind1) != finddad(ind2))cnt--;
    merge(ind1, ind2);
}

void solve()
{
    lli n, m;
    cin >> n >> m;
    arr.resize(n + 1);
    arr[0].resize(m + 2, 0);
    dsu.resize((n+1) * (m+1) + 1);
    for (int i = 1; i <= n; i++) {
        arr[i].resize(m + 2,0);
        for (int j = 1; j <= m; j++)cin >> arr[i][j];
    }
    cntpref.resize(m + 2);
    cntsuf.resize(m + 2);

    lli cnt = 0;
    for (int i = 1; i <= (n + 1) * (m + 1); i++)dsu[i] = i;
    for (int j = 1; j <= m; j++) {
        for (int i = 1; i <= n; i++) {
            cnt++;
            lli ind1 = i * m + j;
            lli ind2 = i * m + j - 1;
            lli ind3 = (i - 1) * m + j;
            if (arr[i][j] == arr[i][j - 1])func(ind1, ind2,cnt);
            if (arr[i][j] == arr[i - 1][j])func(ind1, ind3, cnt);
        }
        cntpref[j] = cnt;
    }


    cnt = 0;
    for (int i = 1; i <= (n + 1) * (m + 1); i++)dsu[i] = i;
    for (int j = m; j >=1; j--) {
        for (int i = 1; i <= n; i++) {
            cnt++;
            lli ind1 = i * m + j;
            lli ind2 = i * m + j + 1;
            lli ind3 = (i - 1) * m + j;
            if (arr[i][j] == arr[i][j + 1])func(ind1, ind2, cnt);
            if (arr[i][j] == arr[i - 1][j])func(ind1, ind3, cnt);
        }
        cntsuf[j] = cnt;
    }
    lli ans = 1e9;
    for (int i = 1; i < m; i++)ans = min(ans, cntpref[i] + cntsuf[i + 1]);
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

