#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
struct dsu {
    vector<int> p,sz;
    int cnt = 0;
    void init(int n) {
        cnt = n;
        p.resize(n);
        sz.resize(n);
        for (int i = 0; i < n; i++) {
            p[i] = i;
            sz[i] = 1;
        }
    }
    int get(int v) {
        if(p[v] == v) return v;
        return p[v] = get(p[v]);
    }
    void unite(int u, int v) {
        u = get(u);
        v = get(v);
        if(u == v) return;
        cnt--;
        if(sz[u] > sz[v]) swap(u,v);
        p[u] = v;
        sz[v] += sz[u];
    }
};

int n,m;
int ansL[500001];
int ansR[500001];
int conv(int x,int y){
    return x*m+y;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    dsu D;
    D.init(n*m);
    vector<vector<int>> a(n,vector<int>(m));
    for (int i = 0;i < n;i++) {
        for (int j = 0; j < m;j++) {
            cin >> a[i][j];
        }
    }
    for(int j = 0; j+1 < m;j++) {
        if(j) {
            for(int i = 0; i < n;i++) {
                if(a[i][j] == a[i][j-1]) {
                    D.unite(conv(i,j),conv(i,j-1));
                }
            }
        }
        for(int i = 0; i+1 < n;i++) {
            if(a[i][j] == a[i+1][j]) {
                D.unite(conv(i,j),conv(i+1,j));
            }
        }
        ansL[j] = D.cnt-n*(m-j-1);
    }
    D.init(n*m);
    for(int j = m-1; j >= 1;j--) {
        if(j < m-1) {
            for(int i = 0; i < n;i++) {
                if(a[i][j] == a[i][j+1]) {
                    D.unite(conv(i,j),conv(i,j+1));
                }
            }
        }
        for(int i = 0; i+1 < n;i++) {
            if(a[i][j] == a[i+1][j]) {
                D.unite(conv(i,j),conv(i+1,j));
            }
        }
        ansR[j-1] = D.cnt-n*j;
    }
    int mn = n*m;
    for(int j = 0; j+1 < m;j++) {
        mn = min(mn,ansL[j]+ansR[j]);
    }
    cout << mn << "\n";

}