#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <math.h>

using namespace std;
typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<string> s(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];
    vector<int> b(m);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (s[i][j] == '.')
                b[j]++;
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ll nwb = 0;
        for (int j = 0; j < m; j++) {
            if (s[i][j] == '.')
                b[j]--;
            else
                b[j]++;
            nwb++;
        }
        int in = 0;
        for (int j = 0; j < m; j++)
            if (n - b[in] - b[in] < n - b[j] * 2)
                in = j;
        nwb -= b[in];
        nwb += n - b[in];
        ans = max(ans, n * 1ll * m - nwb);
    }
    cout << ans << " " << n * 1ll * m - ans << "\n";
}