#include <bits/stdc++.h>
using namespace std;

int n, m;
vector<int> buf;
vector<pair<int,int>> buf2;
vector<vector<int>> a;
vector<vector<pair<int,int>>> p;
vector<vector<int>> sz;

pair<int,int> par(int x, int y) {
    if (p[x][y]==make_pair(x,y)) return {x,y};
    return p[x][y] = par(p[x][y].first,p[x][y].second);
}

void unit(int x1, int y1, int x2, int y2) {
    auto v1 = par(x1,y1);
    auto v2 = par(x2,y2);
    p[v1.first][v1.second] = v2;
    sz[v1.first][v1.second] += sz[v2.first][v2.second];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    buf.resize(m+2);
    buf2.resize(m+2);
    a.assign(n+2,buf);
    sz.assign(n+2,buf);
    p.assign(n+2,buf2);
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> a[i][j];
            p[i][j] = {i,j}; //cout << p[i][j] << " ";
        }
    }
    int k = 0;
    vector<int> dp(m+1), dp2(m+1);
    for (int j = 1; j <= m; j++) {
        k+=n;
        for (int i = 1; i <= n; i++) {
            if (a[i][j-1] == a[i][j] && par(i,j-1)!=par(i,j)) {
                unit(i,j,i,j-1);
                k--;
            }
            if (a[i+1][j] == a[i][j] && par(i+1,j)!=par(i,j)) {
                unit(i,j,i+1,j);
                k--;
            }
        }
        //cout << k << " ";
        dp[j] = k;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            p[i][j] = {i,j};
        }
    }
    k = 0;
    for (int j = m; j >= 1; j--) {
        k+=n;
        for (int i = n; i >= 1; i--) {
            if (a[i][j+1] == a[i][j] && par(i,j+1)!=par(i,j)) {
                unit(i,j,i,j+1);
                k--;
            }
            if (a[i-1][j] == a[i][j] && par(i-1,j)!=par(i,j)) {
                unit(i,j,i-1,j);
                k--;
            }
        }
        //cout << k << " ";
        dp2[j] = k;
    }
    int res = 1e9;
    for (int i = 2; i <= m; i++) {
        //cout << dp[i-1] << " " << dp2[i] << endl;
        res = min(res,dp[i-1]+dp2[i]);
    }
    cout << res;
}
