#include <algorithm>
#include <climits>
#include <cmath>
#include <cstring>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <vector>

using namespace std;

#define ll long long
#define lf long double
#define ull unsigned long long
#define ul unsigned long
#define nl "\n"
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

struct node {
  ll row;
  ll col;
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll n, m, k;
  ll a, b, c, d, e, f, g, l, r, mx, mn, sm;
  bool bl;
  string str;
  char ch;
  ll h, w;
  cin >> h >> w;
  ll arr[h][w];
  for (ll i = 0; i < h; i++) {
    for (ll j = 0; j < w; j++) {
      cin >> arr[i][j];
    }
  }
  vector<ll> column_connections(w - 1, 0);
  ll groups = 0;
  bool visited[h][w];
  memset(visited, false, h * w);
  map<ll, bool> column_visited;
  stack<node> dfs;
  for (ll j = 0; j < w; j++) {
    for (ll i = 0; i < h; i++) {
      if (!visited[i][j]) {
        groups++;
        column_visited.clear();
        dfs.push({i, j});
        while (!dfs.empty()) {
          node current = dfs.top();
          dfs.pop();
          visited[current.row][current.col] = true;
          column_visited[current.col] = true;
          if (current.row > 0 &&
              arr[current.row - 1][current.col] ==
                  arr[current.row][current.col] &&
              !visited[current.row - 1][current.col]) {
            dfs.push({current.row - 1, current.col});
          }
          if (current.row < h - 1 &&
              arr[current.row + 1][current.col] ==
                  arr[current.row][current.col] &&
              !visited[current.row + 1][current.col]) {
            dfs.push({current.row + 1, current.col});
          }
          if (current.col > 0 &&
              arr[current.row][current.col - 1] ==
                  arr[current.row][current.col] &&
              !visited[current.row][current.col - 1]) {
            dfs.push({current.row, current.col - 1});
          }
          if (current.col < w - 1 &&
              arr[current.row][current.col + 1] ==
                  arr[current.row][current.col] &&
              !visited[current.row][current.col + 1]) {
            dfs.push({current.row, current.col + 1});
          }
        }
        for (ll k = 0; k < w - 1; k++) {
          if (column_visited[k] && column_visited[k + 1]) {
            column_connections[k]++;
          }
        }
      }
    }
  }
  mn = LLONG_MAX;
  for (ll i : column_connections) {
    mn = min(mn, i);
  }
  cout << groups + mn;
}
