#include <bits/stdc++.h>

using namespace std;

long long h, w;
vector<long long> v[500005], inc, used1[500005];
vector<bool> us1, us2;

long long flood(long long x, long long y, long long num, long long stnum, long long iter)
{
    if(x<0||y<0||x>=h||y>w||used1[x][y]==iter||v[x][y]!=stnum)
        return -500005;

    used1[x][y]=iter;
    //v[x][y]=num;

    long long p1, p2, p3, p4;

    p1=flood(x+1, y, num, stnum, iter);
    p2=flood(x-1, y, num, stnum, iter);
    p3=flood(x, y+1, num, stnum, iter);
    p4=flood(x, y-1, num, stnum, iter);

    return max(y, max(max(p1, p2), max(p3, p4)));
}

long long floodcheck(long long iter)
{
    long long nc=0;

    for(auto i=0; i<h; i++)
        for(auto j=0; j<=w; j++)
            if(v[i][j]!=-1&&used1[i][j]!=iter)
            {
                long long fl=flood(i, j, nc, v[i][j], iter);
                nc++;
            }

    return nc;
}

int main()
{
    cin>>h>>w;

    for(auto i=0; i<h; i++)
        for(auto j=0; j<w; j++)
        {
            long long x;
            cin>>x;

            v[i].push_back(x);
            used1[i].push_back(-1);
        }

    for(auto i=0; i<h; i++)
        used1[i].push_back(-1);

    long long mink=5000005;

    for(auto i=0; i<w-1; i++)
    {
        for(auto j=0; j<h; j++)
            v[j].insert(v[j].begin()+i+1, -1);

        long long tmk=floodcheck(i);
        mink=min(mink, tmk);

        for(auto j=0; j<h; j++)
            v[j].erase(v[j].begin()+i+1);
    }

    cout<<mink;

    return 0;
}


/**
00 77777
11 88888
21 38444
11 88888
51 66666


0000000
1111111
2131444
1111111
5166666

7  0 0 0 0 0 0
1  1 1 1 1 1 1
2  1 3 1 4 4 4
1  1 1 1 1 1 1
5  1 6 6 6 6 6

2 2 2 2 2 2 2
1 1 1 1 1 1 1
2 1 2 1 2 2 2
1 1 1 1 1 1 1
2 1 2 2 2 2 2
*/
